#pragma once

#include "first_level_ns.h"

void SomeGlobalFunc(int param1);

extern int SomeGlobalVar;

struct SomeRootStruct;
union SomeRootUnion;


typedef int ASimpleVarTypeDef;
typedef int ASimpleFuncTypeDef(int iParam1,ASimpleVarTypeDef Param2);
typedef ASimpleFuncTypeDef *ASimplePtrFuncTypeDef;
typedef ASimpleVarTypeDef *ASimplePtrVarTypeDef;

#define SOME_DEFINE		117

/*!
\brief
Some Brief description of the SOME_OTHER_DEFINE macro here.

A detailed paragraph.

\param x
Some description of parameter x.

\param y
Some description of parameter y.

\see
SOME_DEFINE
*/
#define SOME_OTHER_DEFINE(x,y)			x*y

class SomeRootClass
{
public:
/*! @name Construction and destruction
\brief
A brief comment for that group.

First section of a more detailed description. These are not used for now.. .

Second section of a more detailed description.
*/
//@{
	SomeRootClass();
	explicit SomeRootClass(int param);
	virtual ~SomeRootClass();
//@}
	
	int SomePublicMethod(int param1,double param2);
	const SomeRootStruct *SomePublicVariable;

	SomeRootClass &operator=(const SomeRootClass &other);

protected:
	virtual float SomeProtectedFunc(SomeRootUnion &param1);
	inline void SomeInlineFunc() const
	{
	}

	bool SomeProtectedVariable;

private:

	enum SomePrivateInnerEnum
	{
		VAL117,
		VAL129
	};

	inline void SomePrivateFunc()
	{
	}
};

struct SomeRootStruct
{
	SomeRootClass SomeMember;
	static bool SomeTestFunc();
protected:
	class SomeInnerClass
	{
		double _with_a_member;
	};
};

union SomeRootUnion
{
	struct skrald
	{
		bool tester;
	} InnerTypeVar;
	bool SomeMember;
	float AFuncHere(int param);
protected:
	unsigned int SomeProtectedMember;
};

template <class Inner1,SomeRootStruct *Inner2 = null>
class SomeOtherRootClass : public SomeRootNamespace::SomeInnerClass, protected SomeRootClass
{
public:
	Inner1 _SomeMember;
};